// Code generated by easyjson for marshaling/unmarshaling. DO NOT EDIT.

package entity

import (
	json "encoding/json"
	easyjson "github.com/mailru/easyjson"
	jlexer "github.com/mailru/easyjson/jlexer"
	jwriter "github.com/mailru/easyjson/jwriter"
)

// suppress unused package warning
var (
	_ *json.RawMessage
	_ *jlexer.Lexer
	_ *jwriter.Writer
	_ easyjson.Marshaler
)

func easyjson193538d8DecodeGitlabComDennisKhassanHlcupEntity(in *jlexer.Lexer, out *PremiumRaw) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeString()
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "start":
			out.Start = int32(in.Int32())
		case "finish":
			out.Finish = int32(in.Int32())
		default:
			in.SkipRecursive()
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}
func easyjson193538d8EncodeGitlabComDennisKhassanHlcupEntity(out *jwriter.Writer, in PremiumRaw) {
	out.RawByte('{')
	first := true
	_ = first
	{
		const prefix string = ",\"start\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.Int32(int32(in.Start))
	}
	{
		const prefix string = ",\"finish\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.Int32(int32(in.Finish))
	}
	out.RawByte('}')
}

// MarshalJSON supports json.Marshaler interface
func (v PremiumRaw) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	easyjson193538d8EncodeGitlabComDennisKhassanHlcupEntity(&w, v)
	return w.Buffer.BuildBytes(), w.Error
}

// MarshalEasyJSON supports easyjson.Marshaler interface
func (v PremiumRaw) MarshalEasyJSON(w *jwriter.Writer) {
	easyjson193538d8EncodeGitlabComDennisKhassanHlcupEntity(w, v)
}

// UnmarshalJSON supports json.Unmarshaler interface
func (v *PremiumRaw) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	easyjson193538d8DecodeGitlabComDennisKhassanHlcupEntity(&r, v)
	return r.Error()
}

// UnmarshalEasyJSON supports easyjson.Unmarshaler interface
func (v *PremiumRaw) UnmarshalEasyJSON(l *jlexer.Lexer) {
	easyjson193538d8DecodeGitlabComDennisKhassanHlcupEntity(l, v)
}
func easyjson193538d8DecodeGitlabComDennisKhassanHlcupEntity1(in *jlexer.Lexer, out *NewLikesRaw) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeString()
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "likes":
			if in.IsNull() {
				in.Skip()
				out.Likes = nil
			} else {
				in.Delim('[')
				if out.Likes == nil {
					if !in.IsDelim(']') {
						out.Likes = make([]*NewLikeRaw, 0, 8)
					} else {
						out.Likes = []*NewLikeRaw{}
					}
				} else {
					out.Likes = (out.Likes)[:0]
				}
				for !in.IsDelim(']') {
					var v1 *NewLikeRaw
					if in.IsNull() {
						in.Skip()
						v1 = nil
					} else {
						if v1 == nil {
							v1 = new(NewLikeRaw)
						}
						if data := in.Raw(); in.Ok() {
							in.AddError((*v1).UnmarshalJSON(data))
						}
					}
					out.Likes = append(out.Likes, v1)
					in.WantComma()
				}
				in.Delim(']')
			}
		default:
			in.SkipRecursive()
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}
func easyjson193538d8EncodeGitlabComDennisKhassanHlcupEntity1(out *jwriter.Writer, in NewLikesRaw) {
	out.RawByte('{')
	first := true
	_ = first
	{
		const prefix string = ",\"likes\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		if in.Likes == nil && (out.Flags&jwriter.NilSliceAsEmpty) == 0 {
			out.RawString("null")
		} else {
			out.RawByte('[')
			for v2, v3 := range in.Likes {
				if v2 > 0 {
					out.RawByte(',')
				}
				if v3 == nil {
					out.RawString("null")
				} else {
					out.Raw((*v3).MarshalJSON())
				}
			}
			out.RawByte(']')
		}
	}
	out.RawByte('}')
}

// MarshalJSON supports json.Marshaler interface
func (v NewLikesRaw) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	easyjson193538d8EncodeGitlabComDennisKhassanHlcupEntity1(&w, v)
	return w.Buffer.BuildBytes(), w.Error
}

// MarshalEasyJSON supports easyjson.Marshaler interface
func (v NewLikesRaw) MarshalEasyJSON(w *jwriter.Writer) {
	easyjson193538d8EncodeGitlabComDennisKhassanHlcupEntity1(w, v)
}

// UnmarshalJSON supports json.Unmarshaler interface
func (v *NewLikesRaw) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	easyjson193538d8DecodeGitlabComDennisKhassanHlcupEntity1(&r, v)
	return r.Error()
}

// UnmarshalEasyJSON supports easyjson.Unmarshaler interface
func (v *NewLikesRaw) UnmarshalEasyJSON(l *jlexer.Lexer) {
	easyjson193538d8DecodeGitlabComDennisKhassanHlcupEntity1(l, v)
}
func easyjson193538d8DecodeGitlabComDennisKhassanHlcupEntity2(in *jlexer.Lexer, out *NewLikeRaw) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeString()
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "likee":
			out.Likee = int32(in.Int32())
		case "liker":
			out.Liker = int32(in.Int32())
		case "ts":
			out.Timestamp = int32(in.Int32())
		default:
			in.SkipRecursive()
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}
func easyjson193538d8EncodeGitlabComDennisKhassanHlcupEntity2(out *jwriter.Writer, in NewLikeRaw) {
	out.RawByte('{')
	first := true
	_ = first
	{
		const prefix string = ",\"likee\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.Int32(int32(in.Likee))
	}
	{
		const prefix string = ",\"liker\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.Int32(int32(in.Liker))
	}
	{
		const prefix string = ",\"ts\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.Int32(int32(in.Timestamp))
	}
	out.RawByte('}')
}

// MarshalJSON supports json.Marshaler interface
func (v NewLikeRaw) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	easyjson193538d8EncodeGitlabComDennisKhassanHlcupEntity2(&w, v)
	return w.Buffer.BuildBytes(), w.Error
}

// MarshalEasyJSON supports easyjson.Marshaler interface
func (v NewLikeRaw) MarshalEasyJSON(w *jwriter.Writer) {
	easyjson193538d8EncodeGitlabComDennisKhassanHlcupEntity2(w, v)
}

// UnmarshalJSON supports json.Unmarshaler interface
func (v *NewLikeRaw) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	easyjson193538d8DecodeGitlabComDennisKhassanHlcupEntity2(&r, v)
	return r.Error()
}

// UnmarshalEasyJSON supports easyjson.Unmarshaler interface
func (v *NewLikeRaw) UnmarshalEasyJSON(l *jlexer.Lexer) {
	easyjson193538d8DecodeGitlabComDennisKhassanHlcupEntity2(l, v)
}
func easyjson193538d8DecodeGitlabComDennisKhassanHlcupEntity3(in *jlexer.Lexer, out *LikeRaw) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeString()
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "id":
			out.Id = int32(in.Int32())
		case "ts":
			out.Timestamp = int32(in.Int32())
		default:
			in.SkipRecursive()
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}
func easyjson193538d8EncodeGitlabComDennisKhassanHlcupEntity3(out *jwriter.Writer, in LikeRaw) {
	out.RawByte('{')
	first := true
	_ = first
	{
		const prefix string = ",\"id\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.Int32(int32(in.Id))
	}
	{
		const prefix string = ",\"ts\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.Int32(int32(in.Timestamp))
	}
	out.RawByte('}')
}

// MarshalJSON supports json.Marshaler interface
func (v LikeRaw) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	easyjson193538d8EncodeGitlabComDennisKhassanHlcupEntity3(&w, v)
	return w.Buffer.BuildBytes(), w.Error
}

// MarshalEasyJSON supports easyjson.Marshaler interface
func (v LikeRaw) MarshalEasyJSON(w *jwriter.Writer) {
	easyjson193538d8EncodeGitlabComDennisKhassanHlcupEntity3(w, v)
}

// UnmarshalJSON supports json.Unmarshaler interface
func (v *LikeRaw) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	easyjson193538d8DecodeGitlabComDennisKhassanHlcupEntity3(&r, v)
	return r.Error()
}

// UnmarshalEasyJSON supports easyjson.Unmarshaler interface
func (v *LikeRaw) UnmarshalEasyJSON(l *jlexer.Lexer) {
	easyjson193538d8DecodeGitlabComDennisKhassanHlcupEntity3(l, v)
}
func easyjson193538d8DecodeGitlabComDennisKhassanHlcupEntity4(in *jlexer.Lexer, out *AccountsRaw) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeString()
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "accounts":
			if in.IsNull() {
				in.Skip()
				out.Accounts = nil
			} else {
				in.Delim('[')
				if out.Accounts == nil {
					if !in.IsDelim(']') {
						out.Accounts = make([]AccountRaw, 0, 1)
					} else {
						out.Accounts = []AccountRaw{}
					}
				} else {
					out.Accounts = (out.Accounts)[:0]
				}
				for !in.IsDelim(']') {
					var v4 AccountRaw
					if data := in.Raw(); in.Ok() {
						in.AddError((v4).UnmarshalJSON(data))
					}
					out.Accounts = append(out.Accounts, v4)
					in.WantComma()
				}
				in.Delim(']')
			}
		default:
			in.SkipRecursive()
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}
func easyjson193538d8EncodeGitlabComDennisKhassanHlcupEntity4(out *jwriter.Writer, in AccountsRaw) {
	out.RawByte('{')
	first := true
	_ = first
	{
		const prefix string = ",\"accounts\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		if in.Accounts == nil && (out.Flags&jwriter.NilSliceAsEmpty) == 0 {
			out.RawString("null")
		} else {
			out.RawByte('[')
			for v5, v6 := range in.Accounts {
				if v5 > 0 {
					out.RawByte(',')
				}
				out.Raw((v6).MarshalJSON())
			}
			out.RawByte(']')
		}
	}
	out.RawByte('}')
}

// MarshalJSON supports json.Marshaler interface
func (v AccountsRaw) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	easyjson193538d8EncodeGitlabComDennisKhassanHlcupEntity4(&w, v)
	return w.Buffer.BuildBytes(), w.Error
}

// MarshalEasyJSON supports easyjson.Marshaler interface
func (v AccountsRaw) MarshalEasyJSON(w *jwriter.Writer) {
	easyjson193538d8EncodeGitlabComDennisKhassanHlcupEntity4(w, v)
}

// UnmarshalJSON supports json.Unmarshaler interface
func (v *AccountsRaw) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	easyjson193538d8DecodeGitlabComDennisKhassanHlcupEntity4(&r, v)
	return r.Error()
}

// UnmarshalEasyJSON supports easyjson.Unmarshaler interface
func (v *AccountsRaw) UnmarshalEasyJSON(l *jlexer.Lexer) {
	easyjson193538d8DecodeGitlabComDennisKhassanHlcupEntity4(l, v)
}
func easyjson193538d8DecodeGitlabComDennisKhassanHlcupEntity5(in *jlexer.Lexer, out *AccountRaw) {
	isTopLevel := in.IsStart()
	if in.IsNull() {
		if isTopLevel {
			in.Consumed()
		}
		in.Skip()
		return
	}
	in.Delim('{')
	for !in.IsDelim('}') {
		key := in.UnsafeString()
		in.WantColon()
		if in.IsNull() {
			in.Skip()
			in.WantComma()
			continue
		}
		switch key {
		case "id":
			out.Id = uint32(in.Uint32())
		case "email":
			out.Email = string(in.String())
		case "fname":
			out.FirstName = string(in.String())
		case "sname":
			out.SecondName = string(in.String())
		case "phone":
			out.Phone = string(in.String())
		case "sex":
			out.Sex = string(in.String())
		case "birth":
			out.Birth = int32(in.Int32())
		case "country":
			out.Country = string(in.String())
		case "city":
			out.City = string(in.String())
		case "joined":
			out.Joined = uint32(in.Uint32())
		case "status":
			out.Status = string(in.String())
		case "interests":
			if in.IsNull() {
				in.Skip()
				out.Interests = nil
			} else {
				in.Delim('[')
				if out.Interests == nil {
					if !in.IsDelim(']') {
						out.Interests = make([]string, 0, 4)
					} else {
						out.Interests = []string{}
					}
				} else {
					out.Interests = (out.Interests)[:0]
				}
				for !in.IsDelim(']') {
					var v7 string
					v7 = string(in.String())
					out.Interests = append(out.Interests, v7)
					in.WantComma()
				}
				in.Delim(']')
			}
		case "premium":
			if data := in.Raw(); in.Ok() {
				in.AddError((out.Premium).UnmarshalJSON(data))
			}
		case "likes":
			if in.IsNull() {
				in.Skip()
				out.Likes = nil
			} else {
				in.Delim('[')
				if out.Likes == nil {
					if !in.IsDelim(']') {
						out.Likes = make([]LikeRaw, 0, 8)
					} else {
						out.Likes = []LikeRaw{}
					}
				} else {
					out.Likes = (out.Likes)[:0]
				}
				for !in.IsDelim(']') {
					var v8 LikeRaw
					if data := in.Raw(); in.Ok() {
						in.AddError((v8).UnmarshalJSON(data))
					}
					out.Likes = append(out.Likes, v8)
					in.WantComma()
				}
				in.Delim(']')
			}
		default:
			in.SkipRecursive()
		}
		in.WantComma()
	}
	in.Delim('}')
	if isTopLevel {
		in.Consumed()
	}
}
func easyjson193538d8EncodeGitlabComDennisKhassanHlcupEntity5(out *jwriter.Writer, in AccountRaw) {
	out.RawByte('{')
	first := true
	_ = first
	{
		const prefix string = ",\"id\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.Uint32(uint32(in.Id))
	}
	{
		const prefix string = ",\"email\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.String(string(in.Email))
	}
	{
		const prefix string = ",\"fname\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.String(string(in.FirstName))
	}
	{
		const prefix string = ",\"sname\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.String(string(in.SecondName))
	}
	{
		const prefix string = ",\"phone\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.String(string(in.Phone))
	}
	{
		const prefix string = ",\"sex\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.String(string(in.Sex))
	}
	{
		const prefix string = ",\"birth\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.Int32(int32(in.Birth))
	}
	{
		const prefix string = ",\"country\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.String(string(in.Country))
	}
	{
		const prefix string = ",\"city\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.String(string(in.City))
	}
	{
		const prefix string = ",\"joined\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.Uint32(uint32(in.Joined))
	}
	{
		const prefix string = ",\"status\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.String(string(in.Status))
	}
	{
		const prefix string = ",\"interests\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		if in.Interests == nil && (out.Flags&jwriter.NilSliceAsEmpty) == 0 {
			out.RawString("null")
		} else {
			out.RawByte('[')
			for v9, v10 := range in.Interests {
				if v9 > 0 {
					out.RawByte(',')
				}
				out.String(string(v10))
			}
			out.RawByte(']')
		}
	}
	{
		const prefix string = ",\"premium\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		out.Raw((in.Premium).MarshalJSON())
	}
	{
		const prefix string = ",\"likes\":"
		if first {
			first = false
			out.RawString(prefix[1:])
		} else {
			out.RawString(prefix)
		}
		if in.Likes == nil && (out.Flags&jwriter.NilSliceAsEmpty) == 0 {
			out.RawString("null")
		} else {
			out.RawByte('[')
			for v11, v12 := range in.Likes {
				if v11 > 0 {
					out.RawByte(',')
				}
				out.Raw((v12).MarshalJSON())
			}
			out.RawByte(']')
		}
	}
	out.RawByte('}')
}

// MarshalJSON supports json.Marshaler interface
func (v AccountRaw) MarshalJSON() ([]byte, error) {
	w := jwriter.Writer{}
	easyjson193538d8EncodeGitlabComDennisKhassanHlcupEntity5(&w, v)
	return w.Buffer.BuildBytes(), w.Error
}

// MarshalEasyJSON supports easyjson.Marshaler interface
func (v AccountRaw) MarshalEasyJSON(w *jwriter.Writer) {
	easyjson193538d8EncodeGitlabComDennisKhassanHlcupEntity5(w, v)
}

// UnmarshalJSON supports json.Unmarshaler interface
func (v *AccountRaw) UnmarshalJSON(data []byte) error {
	r := jlexer.Lexer{Data: data}
	easyjson193538d8DecodeGitlabComDennisKhassanHlcupEntity5(&r, v)
	return r.Error()
}

// UnmarshalEasyJSON supports easyjson.Unmarshaler interface
func (v *AccountRaw) UnmarshalEasyJSON(l *jlexer.Lexer) {
	easyjson193538d8DecodeGitlabComDennisKhassanHlcupEntity5(l, v)
}
